<?php
require 'database.php';
//Inside this class is constructed the connection to the database
class DatabaseBackend extends Database{
	public function  __construct(){
		parent::__construct("localhost", "mylea_beta", "root", "csskti$$1154");
	}

	public function login($userid, $password, $role = NULL) {
		//$userid = $mysqli->real_escape_string($userid);
        //$password = $mysqli->real_escape_string($password);

        //$password = md5($password);
        $password = base64_encode(mcrypt_encrypt( MCRYPT_RIJNDAEL_128, '1234567890123456', $password, MCRYPT_MODE_CBC, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"));

		//$password = $this->encrypt($password);
        $sql = "";
        
        if($role){
        	$sql = "SELECT * FROM people WHERE userid = '$userid' AND password='$password'  AND role=$role";
        }else{
        	$sql = "SELECT * FROM people WHERE userid = '$userid' AND password='$password'";
        }
        
        $result = $this->getResultsQuery($sql);

        if (count($result) > 0 ) {
        	return $result[0];
        } else {
      		return 0;
        }
	} 

	// fetches a group by id
	public function getGroup($id){
		$sql = "SELECT * FROM groups WHERE id = $id";
		return $this->getResultsQuery($sql);
	}

	// fetches all the teacher groups
	public function getGroupsByTeacherId($teacherId){
		$sql = "SELECT groups.name, groups.id
				FROM groups
				INNER JOIN teacher_has_groups
				ON groups.id = teacher_has_groups.groupid
				WHERE teacherid = $teacherId";
		//echo $sql;

		return $this->getResultsQuery($sql);
	}

	public function getStudentsByGroupId($id){
		$sql = "SELECT
					P.id AS id, 
					IFNULL(IMG.webPath,  CONCAT('images/std/', FLOOR(RAND() * 9), '.png')) AS icon,
					P.firstname as firstname
				FROM people P
				LEFT JOIN image IMG
					ON P.icon = IMG.id
				INNER JOIN group_has_students GHS
					ON GHS.studentid = P.id
				WHERE role = 2 
				AND groupid = $id" ;
		#echo $sql;
		return $this->getResultsQuery($sql);
	}

	// fetches all students that have the group given by id
	public function getSubjectsByTeacherId($teacherId){
		$sql = "SELECT 
					subjects.id, 
					subjects.name 
				FROM subjects 
				INNER JOIN teacher_has_subjects ON subjects.id = teacher_has_subjects.subjectid
				WHERE teacherid = $teacherId";
				//echo $sql;
		return $this->getResultsQuery($sql);

	}	
	// fetches all students that have the group given by teacher id and group id
	public function getSubjectsByTeacherIdAndGroup($teacherId, $groupId){
		$sql = "SELECT 
					S.id, 
					S.name 
				FROM subjects S
				INNER JOIN teacher_has_subjects THS 
					ON S.id = THS.subjectid
				INNER JOIN group_has_subjects GHS
					ON S.id = GHS.subjectid
				WHERE teacherid = $teacherId";
				//echo $sql;
		return $this->getResultsQuery($sql);

	}	
	// fetches a subject by id
	public function getSubject($id){
		$sql = "SELECT * FROM subjects WHERE id = $id";
		return $this->getResultsQuery($sql);
	}

	//fetches students activities given by teacher id and subject id
	public function getStudentsActivities($studentID, $teacherID, $subjectID){
	
		$sql= "SELECT
					A.id,
					A.name, 
					AI.webPath, 
				IFNULL(SUM(L.value), 0) as value
				FROM activities A
				LEFT JOIN activitieslog L
					ON A.id = L.activityid 
				LEFT JOIN activity_has_images AI
					ON A.icon = AI.id
				INNER JOIN activities_has_subjects AHS
					ON A.id = AHS.activityid
				INNER JOIN group_has_subjects GHS
					ON AHS.subjectid = GHS.subjectid
				INNER JOIN group_has_students GHST
					ON GHS.groupid =  GHST.groupid 
				INNER JOIN teacher_has_subjects THS
					ON THS.subjectid =  AHS.subjectid 
				WHERE
					GHST.studentid = $studentID AND 
					THS.teacherid= $teacherID AND
					AHS.subjectid = $subjectID
				GROUP BY A.id"; 
	
		return $this->getResultsQuery($sql);
	}

	//
	public function insertActivityLog($studentId, $activityId, $groupId, $teacherId, $mindmapId, $value){
		$sql = "INSERT INTO activitieslog (id, activityid, mindmapid, groupid, teacherid, value, studentid) 
				VALUES (NULL, $activityId, $mindmapId, $groupId, $teacherId, $value, $studentId)";
		return $this->executeInsertQuery($sql);
	}

	// fetches mindmap competencies
	public function getMindMapCompetenciesByIdForStudent($id, $studentid){
		$sql = "SELECT  MC.id AS cid,
						MC.name AS cname,
						ME.id AS eid,
						ME.name AS ename,
						ME.priority AS priority,
						IFNULL(SE.value, 0) as value
				FROM competencies MC
				INNER JOIN mindmapevidences ME
					ON ME.competenceid = MC.id
				LEFT JOIN studentevidences SE 
					ON SE.evidence = ME.name AND studentid = $studentid
				WHERE mindmapid = $id 
				ORDER BY priority";

		#echo $sql;
		return $this->getResultsQuery($sql);
	}

	public function deleteStudentsEvidences( $studentid, $evidence){
		$sql = "DELETE FROM studentevidences 
				WHERE studentid = $studentid AND evidence='$evidence'";
		echo $sql;
		return $this->executeQuery($sql);
	}

	public function addStudentsEvidences($studentid, $evidence, $value){
		$sql = "INSERT INTO studentevidences(id, studentid, evidence, value) 
				VALUES (NULL, '$studentid', '$evidence', '$value')";
		echo "$sql";
		return $this->executeInsertQuery($sql);
	}

	public function insertUpdateStudentsEvidences($studentid, $evidence, $value){
		$sql = "SELECT * FROM studentevidences WHERE studentid = $studentid AND evidence='$evidence'";

		$row = $this->getResultsQuery($sql);
		//print_r($row);

		if(count($row) > 0){
			$sql = "UPDATE studentevidences SET value = $value 
				WHERE studentid = $studentid AND evidence='$evidence'";
			return $this->executeQuery($sql);
		}else{
			$sql = "INSERT INTO studentevidences(id, studentid, evidence, value) 
				VALUES (NULL, '$studentid', '$evidence', '$value')";
			return $this->executeInsertQuery($sql);
		}

		//echo "$sql";
	}

	public function getCharts($teacherid){
		$sql = "SELECT * FROM mindmap
				WHERE teacherid = $teacherid";
				
		return $this->getResultsQuery($sql);
	}

	public function getChartsByGroupAndSubject($teacherid, $groupId, $subjectId){
		//echo 'getChartsByGroupAndSubject';
		$sql = "SELECT * 
				FROM mindmap M
				WHERE 
					teacherid = $teacherid AND
					groupid = $groupId AND
					subjectid = $subjectId 
					";
		//echo $sql;
				
		return $this->getResultsQuery($sql);
	}

	public function getChartsById($id){
		return $this->getResultsQuery("SELECT * FROM mindmap WHERE id=" .$id);

	}

	public function addChart($teacherid, $name, $data, $groupId, $subjectId){
		$sql = "INSERT INTO mindmap(id, teacherid, name, data, groupid, subjectid) 
				VALUES (NULL, '$teacherid', '$name', '$data', $groupId, $subjectId)";
		$id = $this->executeInsertQuery($sql);

		if($id){
			$this->addChartCompetencesAndEvidences($id, $data);
		}

		return $id;
	}

	//it creates competences into the database by seeting the children
	private function addCopmetenceWithChildren($competence, $depth, $parentid, $mindmapId){
		$cname = $competence->title;

		$sql = "INSERT INTO competencies(id, name, mindmapid, parentid) 
							VALUES (NULL, '$cname', $mindmapId, $parentid)";

		$cid = $this->executeInsertQuery($sql);	

		if(property_exists($competence, "ideas")){
			foreach ($competence->ideas as $key => $comp) { 
				$this->addCopmetenceWithChildren($comp, $depth+1, $cid, $mindmapId);

				if($depth ==1 && property_exists($comp, "ideas")){
					$sql = "INSERT INTO mindmapevidences(id, name, competenceid, priority) 
							VALUES ";
					//echo $sql;

					$i = 0;
	                foreach ($comp->ideas as $ekey => $evidence) {
	                    $ename = $evidence->title;
	                    if($i > 0){
	                    	$sql  .= ",";
	                    }

	                    $sql  .= "(NULL, '$ename', $cid, $ekey)";

	                    $i++;
	                }
	                //echo $sql;
	                $this->executeInsertQuery($sql);
				}
			}
		}
	}

	public function addChartCompetencesAndEvidences($id, $strData){
		$this->deleteChartCompetencesAndEvidences($id);
		$competence = json_decode($strData);
		$this->addCopmetenceWithChildren($competence, 0, 'NULL', $id);
	}

	public function deleteChartCompetencesAndEvidences($id){

		$sql = "DELETE 
				FROM competencies
				WHERE mindmapid  = $id"; 
		
		$this->executeQuery($sql);
		
	}

	public function updateChart($id, $teacherid, $name, $data, $groupId, $subjectId){
		$espapeData = $this->mysqlEscapeString($data);

		$sql = "UPDATE mindmap
				SET teacherid = '$teacherid',
					name = '$name',
					data = '$espapeData',
					groupid = $groupId, 
					subjectid = $subjectId
				WHERE id = '$id'";

		//echo $sql;
		$res = $this->executeQuery($sql);
		$this->addChartCompetencesAndEvidences($id, $data);
		return $res;
	}

	public function deleteChart($id){
		$sql = "DELETE FROM mindmap WHERE id = $id";
		return $this->executeQuery($sql); 
	}
}
?>