<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */

Editor::inst($db, 'competencies')
        ->field(
                Field::inst('competencies.name')->validator('Validate::notEmpty'),
                Field::inst( 'competencies.competencyinfluence' ),
                Field::inst('competencies.value'),
                Field::inst('competencies.weight'),
                Field::inst( 'competencies.datasourceid' )
                ->options( function () use ( $db ) {
                    // Use `selectDistinct` to get the full list of names from the
                    // database and then concatenate the first and last names
                    $userList = $db->selectDistinct('datasource', 'id, name,schoolid', null, 'name ASC');
                            $out = array();
                            $out[] = array(
                                                "value" => '',
                                                "label" => 'Select Dataource'
                                            );
                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }

                    return $out;
                } ),
                Field::inst('competencies.id'),
                Field::inst('competencies.description'), 
                Field::inst('competencies.prerequisites'), Field::inst('competencies.parentid'), Field::inst('competencies.childlevel'), Field::inst('competencies.schoolid')
                ->setValue($_SESSION['schoolid'])
        )
        ->join(
                Join::inst('levels', 'array')
                ->join(
                        array('id', 'compid'), array('id', 'levelid'), 'competency_has_levels'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('levels', 'id, name,schoolid', null, 'name ASC');
                            $out = array();
                            
                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }
                            return $out;
                        }
                        ), Field::inst('name')
                ),
                                //to get subjects in compt
                                Join::inst('subjects', 'array')
                ->join(
                        array('id', 'compid'), array('id', 'subjectid'), 'subject_has_competencies'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('subjects', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                )
                                
        )
                                // end subject
                                
        ->join(
                Join::inst('groups', 'array')
                ->join(
                        array('id', 'compid'), array('id', 'groupid'), 'competency_data'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('groups', 'id, name,schoolid', null, 'name ASC');
                            $out = array();
                            
                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }
                            return $out;
                        }
                        ), Field::inst('name')
                )
                                
                                
        )
        ->leftJoin( 'datasource', 'competencies.datasourceid', '=', 'datasource.id' )
        ->where('competencies.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();