<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'groups')
        ->field(
                Field::inst('groups.name')->validator('Validate::notEmpty'),
                Field::inst('groups.id'),
                Field::inst('groups.icon')
                ->upload(
                        Upload::inst($_SERVER['DOCUMENT_ROOT'] . '/mkrwww/leas-portal/configtool_beta/dashboard/upload/group/__ID__.__EXTN__')
                        ->db('group_has_images', 'id', array(
                            'icon' => Upload::DB_FILE_NAME,
                            'fileSize' => Upload::DB_FILE_SIZE,
                            'webPath' => Upload::DB_WEB_PATH,
                            'systemPath' => Upload::DB_SYSTEM_PATH
                        ))
                ), 
                Field::inst('group_has_images.icon'), Field::inst('group_has_images.webPath'), Field::inst('groups.schoolid')
                ->setValue($_SESSION['schoolid'])
        )
        ->join(
                Join::inst('people', 'array')
                ->join(
                        array('id', 'groupid'), array('id', 'studentid'), 'group_has_students'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('people', 'id, firstname,surname, role,schoolid', null, 'firstname ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['role'] == '2' && $row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['firstname'] . ' ' . $row['surname']
                                    );
                                }
                            }

                            return $out;
                        }
                        ), Field::inst('firstname'), Field::inst('surname')
                ), Join::inst('subjects', 'array')
                ->join(
                        array('id', 'groupid'), array('id', 'subjectid'), 'group_has_subjects'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('subjects', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                )
        )
        ->leftJoin('group_has_images', 'group_has_images.id', '=', 'groups.icon')
        ->where('groups.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
