<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
include( "../../php/DataTables.php" );

// DataTables PHP library
// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'people')
        ->field(
                Field::inst('people.userid')->validator('Validate::unique', array(
                                                                                'required' => true,
                                                                                'message' => 'This field is required and must be unique.'
                                                                            )
                                                        ), 
                Field::inst('people.firstname')->validator('Validate::notEmpty'), 
                Field::inst('people.surname')->validator('Validate::notEmpty'),
                Field::inst('people.password')->validator('Validate::notEmpty')->getFormatter( 'Format::decode_password', '1234567890123456' )
                    ->setFormatter( 'Format::encode_password', '1234567890123456' ),
                Field::inst('people.id'), 
                Field::inst('people.language'),
                Field::inst('schools.name'),  
                Field::inst('people.role')
                            ->setValue(2), 
                Field::inst('people.icon')
                            ->upload(
                                    Upload::inst($_SERVER['DOCUMENT_ROOT'] . '/mkrwww/leas-portal2/configtool_beta/dashboard/upload/people/__ID__.__EXTN__')
                                    ->db('image', 'id', array(
                                        'icon' => Upload::DB_FILE_NAME,
                                        'fileSize' => Upload::DB_FILE_SIZE,
                                        'webPath' => Upload::DB_WEB_PATH,
                                        'systemPath' => Upload::DB_SYSTEM_PATH
                                    ))
                            ), 
                Field::inst('image.icon'), 
                Field::inst('image.webPath'), 
                Field::inst('people.schoolid')
                            ->setValue($_SESSION['schoolid'])
        )
        ->join(
            Join::inst( 'levels', 'array' )
                ->join(
                    array( 'id', 'studid' ),
                    array( 'id', 'levelid' ),
                    'student_has_levels'
                )
                ->fields(
                    Field::inst( 'id' )
                        ->options(
                                function () use ($db) {
                                    // Use `selectDistinct` to get the full list of names from the
                                    // database and then concatenate the first and last names
                                    $userList = $db->selectDistinct( 'levels', 'id, name,schoolid', null, 'name ASC' );
                                    $out = array();
//                                    $out[] = array(
//                                                "value" => '',
//                                                "label" => 'Select Level'
//                                            ); 
                                    while ( $row = $userList->fetch() ) {
                                        if($row['schoolid']==$_SESSION['schoolid']){
                                            $out[] = array(
                                                "value" => $row['id'],
                                                "label" => $row['name']
                                            );
                                        }
                                    }
                                    return $out;
                                }
                                ),
                    Field::inst( 'name' )
                )
        )
        ->leftJoin('image', 'image.id', '=', 'people.icon')
        ->leftJoin('schools', 'schools.id', '=', 'people.schoolid')
        ->where('people.role', '2')
        ->where('people.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
