<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'people')
        ->field(
                Field::inst('people.userid')->validator('Validate::unique', array(
                    'required' => true,
                    'message' => 'This field is required and must be unique.')), Field::inst('people.firstname')->validator('Validate::notEmpty'), Field::inst('people.surname')->validator('Validate::notEmpty'), Field::inst('people.password')->validator('Validate::notEmpty')->getFormatter('Format::decode_password', '1234567890123456')
                ->setFormatter('Format::encode_password', '1234567890123456'), Field::inst('people.role')
                ->setValue('1'), Field::inst('people.schoolid')
                ->setValue($_SESSION['schoolid'])
        )
        ->join(
                Join::inst('groups', 'array')
                ->join(
                        array('id', 'teacherid'), array('id', 'groupid'), 'teacher_has_groups'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('groups', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                ), Join::inst('subjects', 'array')
                ->join(
                        array('id', 'teacherid'), array('id', 'subjectid'), 'teacher_has_subjects'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('subjects', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                ), Join::inst('mytools', 'array')
                ->join(
                        array('id', 'teacherid'), array('id', 'toolid'), 'teacher_has_tools'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('mytools', 'id, name', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                $out[] = array(
                                    "value" => $row['id'],
                                    "label" => $row['name']
                                );
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                )
        )
        ->where("people.role", 1)
        ->where('people.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
