
$.fn.clearForm = function() {
    return this.each(function() {
        var type = this.type, tag = this.tagName.toLowerCase();
        if (tag == 'form')
            return $(':input',this).clearForm();
        if (type == 'text' || type == 'password' || tag == 'textarea'|| type == 'hidden' || type == "email")
            this.value = '';
        else if (type == 'checkbox' || type == 'radio')
            this.checked = false;
        else if (tag == 'select')
            this.selectedIndex = -1;
    });
};

jQuery.fn.attachmentEditorWidget = function (mapModel) {
    'use strict';
    return this.each(function () {
        var element = jQuery(this);
        mapModel.addEventListener('attachmentOpened', function (nodeId, attachment) {
            mapModel.setAttachment(
                'attachmentEditorWidget',
                nodeId, {
                    contentType: 'text/html',
                    content: prompt('attachment', attachment && attachment.content)
                }
            );
        });
    });
};

var localVars = {};
localVars.baseUrl = "../webservice/public_html/index.php/"

$(document).ready(function() {
            
    ///$(this).find('.modal-body').css({width:'auto', height:'auto', 'max-height':'800px'});
    $("#login_error_container").hide();

    $( "#frm_log_in" ).submit(function( event ) {
      event.preventDefault();
      login();
    });
    
    $("#main-container").hide();
    $("#navbar").hide();
    $("#login-container").hide();
    

    $("#dlg-check-login").modal();


    $.ajax({
        type: "GET",
        url: localVars.baseUrl + "authenticated",
        success: function(msg){
            //var obj = $.parseJSON(msg);
            obj = msg;

            if(obj["success"]){
                localVars.isLogedIn = true;
            }else{
                localVars.isLogedIn = false;
            }
            $("#dlg-check-login").modal('hide');
            switchViews();
        },
        error: function(){
            localVars.isLogedIn = false;
            $("#dlg-check-login").modal('hide');
            switchViews();
        }
    });

     //$( document ).tooltip();

});


function switchViews(){
    if(localVars.isLogedIn){
        $("#login-container").hide();
        $("#navbar").show();
        $("#main-container").show();
        init();
    }else{
        $("#main-container").hide();
        $("#navbar").hide();
        $("#login-container").show();
    }
}


function login(){
    var data = $('#frm_log_in').serialize();
    $("#login_error_container").text("");
    $("#login_error_container").hide();

    $.ajax({
        type: "POST",
        data: data,
        url: localVars.baseUrl + "login",
        success: function(msg){
            //var obj = $.parseJSON(msg);
            obj = msg;
            if(obj["success"]){
                localVars.isLogedIn = true;
                $("#login-container").hide();
                $("#main-container").show();
                $("#navbar").show();
                $("#login_error_container").hide();
                init();
            }else{
                $("#login_error_container").text(obj["content"]);
                $("#login_error_container").show();
            }
        },
        error: function(){
            $("#login_error_container").text("Connection error! Please try again later!");
            $("#login_error_container").show();
        }
    });
}


function logout(){
    var data = $('#frm_log_out').serialize();
    //$("#login_error_container").text("");
    //$("#login_error_container").hide();

    $.ajax({
        type: "GET",
        data: data,
        url: localVars.baseUrl + "logout",
        success: function(msg){
            //var obj = $.parseJSON(msg);
            obj = msg;
           if(obj["success"]){
                localVars.isLogedIn = false;
                //$("#main-container").hide();
                //$("#login-container").show();
                location.reload();
            }else{
               
            }
        },
        error: function(){
            
        }
    });
}

function init(){
    $.fn.modal.Constructor.prototype.enforceFocus = function () {};

    $('#btn_logout').click(function() {
        logout();
    });

    $("#btn_load_map").click(function () {
        loadSelectedMap();
    });
    $("#btn_load_group").click(function(){
        loadSelectedGroup();
    });

    $("#btn_save_map").click(function () {
        saveCurrentMap();
    });

    $("#select_maps").change(function () {
        //loadSelectedMap();
    });

    $("#btn_new_map").click(function () {
        $("#modal_add_map").modal('toggle');
    });

    $("#btn_group_report").click(function() {
        $("#modal_group_reports").modal('toggle');
    });

    $("#modal_add_map #btn_save").click(function () {
        var name = $("#modal_add_map #name").val();
        var rootIdea = {title: name, id : 1 , "attr" : { "style" : { "background" : "#9e9eff"}}};

        var data = {formatVersion:2, id: 4, title: name};
        addNewMap(name, JSON.stringify(data));
    });

    $(".pick-a-color").pickAColor();

    $("#show_next_student").click(function(){
        //$("#modal_student_items").modal("toggle");
        $('#student_competencies_evidencies').html("");
        var id = $(this).attr("data-id");
        showStudentItems(id, true);
    });

    $("#show_previous_student").click(function(){
        $('#student_competencies_evidencies').html("");
        var id = $(this).attr("data-id");
        showStudentItems(id, true);
    });

    $("#btn_group_report").click(function(){
        showGroupReports();
    });

    $("#btn_print_report").click(function(){
        $("#form-group-report").printArea();
    });

    $("#btn_close_modal_student").click(function(){
        activateTab("tab_lerarning_objectives");
    });

    

    loadMaps();
    loadGroups();

}

function loadGroups(){
    var url = localVars.baseUrl + "groups";
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            var success = obj["success"];
            if(success){
                var content = obj["content"];
                localVars.groups = {};

                $.each(content, function(index, group) {
                    localVars.groups[group.id] = group;
                });

                populateSelectedGroupsControl();

            }else{

            }
        },
        error: function(){
            
        }
    })
}


function loadMaps(){
    var url = localVars.baseUrl + "mindmpap";
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            //var obj = $.parseJSON(msg);
            var success = obj["success"];
            if(success){ 
                var content = obj["content"];
                localVars.maps = {};

                $.each(content, function(index, map) {
                    localVars.maps[map.id] = map;
                });

                populateMapsSelectControl();
            }else{
                //alert(content);
            }
        },
        error: function(){
            //alert("Error: Data could not be saved!");
        }
    });
}

function populateMapsSelectControl(){
    console.log("populateMapsSelectControl");
    var selectedMap = $("#select_maps").val();
    
    $("#select_maps").empty();
    
    $.each(localVars.maps, function(index, map) {
        $('<option/>').val(map.id).html(map.name).appendTo("#select_maps");
    });

    $("#select_maps").val(selectedMap);
}

function populateSelectedGroupsControl(){
    var value = $("#groups").val();
    $("#groups").empty();

    $.each(localVars.groups, function(index, item) {
        $('<option/>').val(item.id).html(item.name).appendTo("#groups");
    });

    $("#groups").val(value);
}


function loadSelectedMap(){
    var selectedMapId = $("#select_maps").val();

    if(selectedMapId){
        $("#chart-holder").show();
        $("#chart-menu").show();
        var selectedMap = localVars.maps[selectedMapId];
        var jsonData = JSON.parse(selectedMap.data);

        $("#txt_map_name").val(selectedMap.name);
        setChartData(jsonData);
        //showAsTable(jsonData, "chart_tree_table");

        /*
        $.get("demo.json", function(data){
            setChartData(data);
        });
        */
    }

}

function activateTab(tab){
    $('.nav-tabs a[href="#' + tab + '"]').tab('show');
}

function loadSelectedGroup(){
    var selectedGroupId = $("#groups").val();
    console.log(selectedGroupId);
    var url = localVars.baseUrl + "studentsforgroup/" + selectedGroupId;

    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            //var obj = $.parseJSON(msg);
            var success = obj["success"];
            if(success){ 
                var content = obj["content"];
                var mainDiv = $('#student-group-row');
                mainDiv.html('');
                localVars.groupStudents = {};

                $.each(content, function(index, student) {                    
                    var itemDiv = $('<div/>').addClass('span3').addClass('people_cell');
                    
                    var next_id = 0;
                    if(index >= content.length -1){
                        next_id = content[0].id;
                    }else{
                        next_id = content[index+1].id;
                    }

                    var previous_id = 0;
                    if(index === 0){
                        previous_id = content[content.length -1].id;
                    }else{
                        previous_id = content[index -1].id;
                    }

                    student.next_id = next_id;
                    student.previous_id = previous_id;
                    localVars.groupStudents[student.id] = student;

                    var itemImage = $('<img/>').attr({
                        src: "img/people/" + student.icon, 
                        "data-id": student.id
                    });

                    itemImage.click(function(){
                        var id = $(this).attr("data-id");
                        showStudentItems(id);
                    });
                    itemDiv.append(itemImage);
                    itemDiv.append(student.firstname);
                    mainDiv.append(itemDiv);
                });
            }else{
                //alert(content);
            }
        },
        error: function(){
            //alert("Error: Data could not be saved!");
        }
    });
}

function showStudentItems(studentId, showNext){
    console.log(studentId);
    if(!showNext) $("#modal_student_items").modal("toggle");
    activateTab("tab_lerarning_objectives");
    var selectedMapId = $("#select_maps").val();
    var selectedGroupId = $('#groups').val();

    //console.log(studentName);
    //console.log(nextStudentId);

    //*****************************************
   // 

   var student = localVars.groupStudents[studentId];
   var studentIcon = student.icon;
   var studentImageStr = "<img src='img/people/" +  studentIcon + "'>";

   $("#selected_student_name").html(student.firstname + studentImageStr);
   $("#show_next_student").attr("data-id", student.next_id);
   $("#show_previous_student").attr("data-id", student.previous_id);

    // show competencies
    console.log(selectedMapId);
    var url = localVars.baseUrl + "competenciesformindmap/" + selectedMapId+ "/" + studentId;
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
           var success = obj["success"];
           if(success){
                var content = obj["content"];
                $('#student_competencies_evidencies').html(""); //e fshin html
                $('#student_competencies_evidencies').hide();
                $.each(content, function(index, competency){
                    //console.log(competency);
                    var mainDiv = $('#student_competencies_evidencies');
                    var itemDiv = $('<div/>').attr('id', 'student-group-row').addClass('row-fluid').appendTo(mainDiv);
                    $('<div/>').addClass('span3').html(competency["name"]).appendTo(itemDiv);
                    
                    $.each(competency.evidences, function(index1, eveidence){
                        //var button1 = $('<button/>').addClass('btn').addClass('btn-primary').addClass('active').html(eveidence["name"]).appendTo(itemDiv);
                        var name = eveidence["name"];
                        name = name.substring(0, 10);
                        

                        var toggleButton = $('<input/>', {
                            "type": "checkbox", 
                            "data-toggle": "toggle",
                            "data-on": name,
                            "data-off": name, 
                            "data-onstyle":"success", 
                            "data-student-id": studentId,
                            "data-evidence-name": eveidence["name"],
                            "data-offstyle":""
                        }).addClass('check-toggle').addClass("evidences-button");
                        
                        if(eveidence["value"] == "1"){
                            toggleButton.attr("checked", "checked");
                        }
                        //if(name != eveidence["name"]){
                            var bntGroup = $('<div/>').addClass('btn-group').appendTo(itemDiv);
                            toggleButton.appendTo(bntGroup);
                            var dropDownButton = $('<button/>', {
                                "type": "button", 
                                "data-toggle": "dropdown",
                                "aria-expanded": "false"
                            }).addClass('btn btn-default dropdown-toggle').appendTo(bntGroup);
                            dropDownButton.append($('<span/>').addClass('caret'));
                            dropDownButton.append($('<span/>').html('&nbsp;').addClass('sr-only'));
                            var ulItem = $('<ul/>',{'role': 'menu'}).addClass('dropdown-menu').appendTo(bntGroup);
                            var liItem = $('<li/>').append().appendTo(ulItem);
                            var aItem = $('<a/>',{'href': '#'}).html(eveidence["name"]).appendTo(liItem);
                        //}else{
                        //    toggleButton.appendTo(itemDiv);
                        //}
                        


                        setTimeout(function(){  
                            toggleButton.change(function(){
                                var sId = parseInt($(this).attr("data-student-id"));
                                var en = $(this).attr("data-evidence-name");
                                var val = $(this).prop('checked') ? 1 : 0;
                                var purl = localVars.baseUrl + "studentevidence";
                                
                                var pdata = {'studentid': sId, 'evidence': en, 'value': val}; 

                                $.ajax({
                                    type: "POST",
                                    dataType: "json",
                                    url: purl,
                                    data: pdata,
                                    success: function(obj){
                                        console.log(obj);
                                    }
                                });
                                
                            });
                        
                        }, 1000);

                        //<input type="checkbox" checked data-toggle="toggle" data-on="Ready" data-off="Not Ready" data-onstyle="success" data-offstyle="danger">
                    });
                    setTimeout(function(){ 
                        $('#student_competencies_evidencies').show();
                        $('.check-toggle').bootstrapToggle(); 
                    }, 300);
                    //$('#student_competencies_evidencies').show();
                    //var textBox =$('<input/>').attr('type', 'text').appendTo(mainDiv);

                   });
           }else {

           }

        },
        error: function(){

        }
 
    });

    //return;
    //show activities
    console.log(selectedMapId);
    var url = localVars.baseUrl + "studentactivities/" + studentId + "/"+ selectedGroupId;
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
           var success = obj["success"];
           if(success){
                var content = obj["content"];
                $('#student_activities').html(""); 
                //$('#student_activities.').hide();
                localVars.currentStudentActivities = {};

                $.each(content, function(index, activity){
                    console.log(activity);

                    localVars.currentStudentActivities[activity.id] = activity;

                    var itemImage = $('<img/>').attr({
                        src: "img/activities/" + activity.icon,
                        'data-id': activity.id,
                        'data-student-id': studentId
                    });

                    var itemDiv = $('<div/>').addClass('span3').append(itemImage);
                    var countActivity = $('<span/>').addClass('badge badge-success count_activity_badge').html(activity.value).appendTo(itemDiv);
                    var deleteActivity = $('<span/>').addClass('badge badge-error delete_activity_badge').html('x').appendTo(itemDiv);
                    
                    countActivity.attr({'id': 'count_acivity_' + activity.id});
                    deleteActivity.attr({'data-id': activity.id, 'data-student-id': studentId});

                    $('<br/>').appendTo(itemDiv);
                    $('<br/>').appendTo(itemDiv);
                    itemDiv.append(activity.name);
                    $('#student_activities').append(itemDiv);

                    itemImage.click(function(){
                        var aid = $(this).attr("data-id");
                        var sid = $(this).attr("data-student-id");

                        increaseStudentActivity(sid, aid);

                        //console.log(aid);
                       // console.log(sid);

                    });
                    
                    deleteActivity.click(function(){
                        var aid = $(this).attr("data-id");
                        var sid = $(this).attr("data-student-id");

                        decreaseStudentActivity(sid, aid);

                        console.log(aid);
                        console.log(sid);

                    });

                });

           }else {

           }

        },
        error: function(){

        }
 
    });

}

function increaseStudentActivity(studentId, activityId){
    var countActivitySpan = $('#count_acivity_' + activityId);
    var currentActivity = localVars.currentStudentActivities[activityId];
    var selectedGroupId = $("#groups").val();
    var selectedMapId = $("#select_maps").val();
    currentActivity.value = parseInt(currentActivity.value) + 1;
    countActivitySpan.html(currentActivity.value);
    var url = localVars.baseUrl + "increaseStudentActivity/" + studentId + '/' +  activityId + '/' + selectedGroupId + '/' + selectedMapId;
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            var success = obj["success"];
            if(success){
                var content = obj["content"];
            }

        },
        error: function(){

        }

    });
}
//******************************************************************

function showGroupReports(){
    var selectedGroupId = $('#groups').val();
    var selectedMindmapId = $("#select_maps").val();
    var url = localVars.baseUrl + "groupreports/" + selectedGroupId + "/" + selectedMindmapId;
    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            var success = obj["success"];
            var mainSpan = $('#form-group-report-span');
            mainSpan.html(""); 

            if(success){
                var content = obj["content"];
                var group = $('#groups option:selected').text();

                var titleDiv = $('<div/>').html("<b>Vzdělávací cíle: " + group + "</b>");
                mainSpan.append(titleDiv).append('<br/>');
                
                $.each(content, function(index, student){

                    var name = student.firstname + " " + student.surname;
                    var sp = student.percentage + "%";

                    var name_span = $('<div/>').addClass('span2').html(name);
                    var sp_span = $('<div/>').addClass('span1').addClass('pull-right').html(sp);
                    var itemDiv = $('<div/>').addClass('row');

                    itemDiv.append(name_span);
                    itemDiv.append(sp_span);

                    mainSpan.append(itemDiv);
                });
            }

           // $('<div>').addClass('span3') 


        },
        error: function(){

        }

    });
}


function decreaseStudentActivity(studentId, activityId){
    var countActivitySpan = $('#count_acivity_' + activityId);
    var currentActivity = localVars.currentStudentActivities[activityId];
    var selectedGroupId = $("#groups").val();
    var selectedMapId = $("#select_maps").val();

    currentActivity.value = parseInt(currentActivity.value) - 1;
    countActivitySpan.html(currentActivity.value);
    var url = localVars.baseUrl + "decreaseStudentActivity/" + studentId + '/' + activityId + '/' + selectedGroupId + '/' + selectedMapId;

    $.ajax({
        type: "GET",
        dataType: "json",
        url: url,
        success: function(obj){
            var success = obj["success"];
            if(success){
                var content = obj["content"];
            }
        },
        error: function(){
            
        }

    }); 
}


function saveCurrentMap(){
    console.log('saveCurrentMap');
    var selectedMapId = $("#select_maps").val();
    var selectedMapName = $("#txt_map_name").val();
    var jsonString = "";

    if(localVars.idea){
        jsonString = JSON.stringify(localVars.idea); 
    }
    
    var postData = {'id': selectedMapId, 'name': selectedMapName, 'data': jsonString};

    $.post( localVars.baseUrl + 'mindmap' , postData, function(data, status){
        //var obj = $.parseJSON(data);
        obj=data;

        var success = obj["success"];
        var content = obj["content"];
        if(success){ 
            var map = localVars.maps[selectedMapId];
            map.name = selectedMapName;
            map.data = jsonString;
            populateMapsSelectControl();
            //showAsTable(localVars.idea, "chart_tree_table");
        }else{
            alert(content);
        }

    }).fail(function(){
        alert("Error: Data could not be saved!");
    });

}


function setChartData(data){
    var container = $('#chart-container');
    container.html('');

    console.log(data);
    localVars.idea = MAPJS.content(data);

    var imageInsertController = new MAPJS.ImageInsertController("http://localhost:4999?u="),
    mapModel = new MAPJS.MapModel(MAPJS.DOMRender.layoutCalculator, []);
    container.domMapWidget(console, mapModel, false, imageInsertController);
    $('body').mapToolbarWidget(mapModel);
    $('body').attachmentEditorWidget(mapModel);
    mapModel.setIdea(localVars.idea);
    $('#linkEditWidget').linkEditWidget(mapModel);
    window.mapModel = mapModel;

}


function addNewMap(name, mapData){
    var postData = {'id': '', 'name': name, 'data': mapData};

    $.post( localVars.baseUrl + 'mindmap' , postData, function(data, status){
        console.log(data);
        //var obj = $.parseJSON(data);
        obj = data

        var success = obj["success"];
        var content = obj["content"];
        if(success){ 
            var id = content["id"];
            localVars.maps[id] = {id: id, name : name, data: mapData};
            populateMapsSelectControl();
            $("#select_maps").val(id);
            loadSelectedMap();
            $("#modal_add_map").modal('hide');
        }else{
            alert(content);
        }
    

    }).fail(function(){
        alert("Error: Data could not be saved!");
    });
} 

function showAsTable(chartData, divID){
    
    var table = $('<table id="maps_tree_table" width="100%" />');
    table.append( '<tr ><th> Id </th><th>Title</th> <th> Parent</th></tr>' );
    table.append( '<tr data-tt-id="'+ chartData.id + '">' + '<td>' + chartData.id + '</td><td>' + chartData.title + '</td> <td> </td></tr>' );
    appendRows(chartData.ideas, chartData.id, table);
    $('#' + divID).html(table);
    
    //jstreetable plugin to make table expandable.
    com_github_culmat_jsTreeTable.register(this);
    treeTable($('#maps_tree_table'));
}

function appendRows(ideas, parentID, table){
    $.each(ideas, function( index, value ) {
        table.append( '<tr data-tt-id="' + value.id+ '" data-tt-parent-id="' + parentID+ '">' + '<td>' + value.id + '</td><td>' + value.title + '</td> <td> ' + parentID +'</td></tr>' );
        if(value.ideas != undefined){
            appendRows(value.ideas, value.id, table);
        }
    });
}

function printContent(element){
    var restorepage = document.body.innerHTML;
    var printcontent = element.html();
    document.body.innerHTML = printcontent;
    window.print();
    document.body.innerHTML = restorepage;
}